var cli = require('cli').enable('help','version','status');
// var cli = require('cli').enable('help','version','status','daemon');

cli.parse({
	logging: ['l','Enable logging'],
	port: ['p','the port the proxy server listens to','number',8087],
	limit: ['L','limit the spped of the connection','bandwidth'],
	interval: [false,'the interval to calculate the limit (melliseconds)','int',1000],
});
var parse_limit = function(str){
	str = str.toString()
	var limit = parseInt(str);
	limit = isNaN(limit)?1:limit;
	if(~str.indexOf('k') || ~str.indexOf('K'))
		limit *= 1024;
	if(~str.indexOf('m') || ~str.indexOf('M'))
		limit *= 1024 * 1024;
	if(~str.indexOf('b'))
		limit *= 8;
	return limit;
};
cli.main(function(args, options){
	return proxy_start(args,options)
});

var proxy_start = function(args, options){
	var Proxy = require('./index');
	var proxy = Proxy();
	if(options.logging){
		cli.debug('Enabling logging');
		proxy.use(require('./examples/logging')(cli.info));
	}
	if(options.limit){
		cli.debug('Enabling BW limit');
		proxy.use(require('./examples/speed_limit')(parse_limit(options.limit),options.interval));
	}
	cli.debug('Starting the server');
	var server = proxy.listen(options.port, function () {
		var host = server.address().address;
		var port = server.address().port;
		cli.ok('proxy server listening at http://'+host+':'+port);
		cli.debug('Server started');
	});
}